@import 'variables';
@import 'utility';

@mixin qa-layout-pesticide() {
  @if fetch($qa, layout-pesticide) {
    body {
      outline: 1px solid #2980b9;
    }

    article {
      outline: 1px solid #3498db;
    }

    nav {
      outline: 1px solid #0088c3;
    }

    aside {
      outline: 1px solid #33a0ce;
    }

    section {
      outline: 1px solid #66b8da;
    }

    header {
      outline: 1px solid #99cfe7;
    }

    footer {
      outline: 1px solid #cce7f3;
    }

    h1 {
      outline: 1px solid #162544;
    }

    h2 {
      outline: 1px solid #314e6e;
    }

    h3 {
      outline: 1px solid #3e5e85;
    }

    h4 {
      outline: 1px solid #449baf;
    }

    h5 {
      outline: 1px solid #c7d1cb;
    }

    h6 {
      outline: 1px solid #4371d0;
    }

    main {
      outline: 1px solid #2f4f90;
    }

    address {
      outline: 1px solid #1a2c51;
    }

    div {
      outline: 1px solid #036cdb;
    }

    p {
      outline: 1px solid #ac050b;
    }

    hr {
      outline: 1px solid #ff063f;
    }

    pre {
      outline: 1px solid #850440;
    }

    blockquote {
      outline: 1px solid #f1b8e7;
    }

    ol {
      outline: 1px solid #ff050c;
    }

    ul {
      outline: 1px solid #d90416;
    }

    li {
      outline: 1px solid #d90416;
    }

    dl {
      outline: 1px solid #fd3427;
    }

    dt {
      outline: 1px solid #ff0043;
    }

    dd {
      outline: 1px solid #e80174;
    }

    figure {
      outline: 1px solid #f0b;
    }

    figcaption {
      outline: 1px solid #bf0032;
    }

    table {
      outline: 1px solid #0c9;
    }

    caption {
      outline: 1px solid #37ffc4;
    }

    thead {
      outline: 1px solid #98daca;
    }

    tbody {
      outline: 1px solid #64a7a0;
    }

    tfoot {
      outline: 1px solid #22746b;
    }

    tr {
      outline: 1px solid #86c0b2;
    }

    th {
      outline: 1px solid #a1e7d6;
    }

    td {
      outline: 1px solid #3f5a54;
    }

    col {
      outline: 1px solid #6c9a8f;
    }

    colgroup {
      outline: 1px solid #6c9a9d;
    }

    button {
      outline: 1px solid #da8301;
    }

    datalist {
      outline: 1px solid #c06000;
    }

    fieldset {
      outline: 1px solid #d95100;
    }

    form {
      outline: 1px solid #d23600;
    }

    input {
      outline: 1px solid #fca600;
    }

    keygen {
      outline: 1px solid #b31e00;
    }

    label {
      outline: 1px solid #ee8900;
    }

    legend {
      outline: 1px solid #de6d00;
    }

    meter {
      outline: 1px solid #e8630c;
    }

    optgroup {
      outline: 1px solid #b33600;
    }

    option {
      outline: 1px solid #ff8a00;
    }

    output {
      outline: 1px solid #ff9619;
    }

    progress {
      outline: 1px solid #e57c00;
    }

    select {
      outline: 1px solid #e26e0f;
    }

    textarea {
      outline: 1px solid #cc5400;
    }

    details {
      outline: 1px solid #33848f;
    }

    summary {
      outline: 1px solid #60a1a6;
    }

    command {
      outline: 1px solid #438da1;
    }

    menu {
      outline: 1px solid #449da6;
    }

    del {
      outline: 1px solid #bf0000;
    }

    ins {
      outline: 1px solid #400000;
    }

    img {
      outline: 1px solid #22746b;
    }

    iframe {
      outline: 1px solid #64a7a0;
    }

    embed {
      outline: 1px solid #98daca;
    }

    object {
      outline: 1px solid #0c9;
    }

    param {
      outline: 1px solid #37ffc4;
    }

    video {
      outline: 1px solid #6ee866;
    }

    audio {
      outline: 1px solid #027353;
    }

    source {
      outline: 1px solid #012426;
    }

    canvas {
      outline: 1px solid #a2f570;
    }

    track {
      outline: 1px solid #59a600;
    }

    map {
      outline: 1px solid #7be500;
    }

    area {
      outline: 1px solid #305900;
    }

    a {
      outline: 1px solid #ff62ab;
    }

    em {
      outline: 1px solid #800b41;
    }

    strong {
      outline: 1px solid #ff1583;
    }

    i {
      outline: 1px solid #803156;
    }

    b {
      outline: 1px solid #cc1169;
    }

    u {
      outline: 1px solid #ff0430;
    }

    s {
      outline: 1px solid #f805e3;
    }

    small {
      outline: 1px solid #d107b2;
    }

    abbr {
      outline: 1px solid #4a0263;
    }

    q {
      outline: 1px solid #240018;
    }

    cite {
      outline: 1px solid #64003c;
    }

    dfn {
      outline: 1px solid #b4005a;
    }

    sub {
      outline: 1px solid #dba0c8;
    }

    sup {
      outline: 1px solid #cc0256;
    }

    time {
      outline: 1px solid #d6606d;
    }

    code {
      outline: 1px solid #e04251;
    }

    kbd {
      outline: 1px solid #5e001f;
    }

    samp {
      outline: 1px solid #9c0033;
    }

    var {
      outline: 1px solid #d90047;
    }

    mark {
      outline: 1px solid #ff0053;
    }

    bdi {
      outline: 1px solid #bf3668;
    }

    bdo {
      outline: 1px solid #6f1400;
    }

    ruby {
      outline: 1px solid #ff7b93;
    }

    rt {
      outline: 1px solid #ff2f54;
    }

    rp {
      outline: 1px solid #803e49;
    }

    span {
      outline: 1px solid #cc2643;
    }

    br {
      outline: 1px solid #db687d;
    }

    wbr {
      outline: 1px solid #db175b;
    }
  }
}

@mixin qa-layout-x-ray() {
  @if fetch($qa, layout-x-ray) {

    $color-x-ray-foreground: #00ffd0;
    $color-x-ray-background: #00483b;

    & {
      padding: 0 !important;
      color: $color-x-ray-foreground !important;
      background-color: $color-x-ray-background !important;
      background-position: left top !important;
      background-image: linear-gradient(0deg, transparent, transparent 15px, rgba($color-x-ray-background, 0.25) 15px), linear-gradient(90deg, transparent, transparent 1rem, rgba($color-x-ray-background, 0.25) 1rem) !important;
      background-size: 1rem 1rem !important;

      * {
        color: $color-x-ray-foreground !important;
        outline: 1px solid rgba($color-x-ray-background, 0.5) !important;
        background-color: rgba($color-x-ray-background, 0.125) !important;
        transition-property: color, background-color !important;
        transition-duration: 0.5s !important;
        transition-timing-function: ease-out !important;
      }
    }
  }
}

@if fetch($env, is-debug) and fetch($qa, layout-enabled) {
  :root {
    @include qa-layout-pesticide();
    @include qa-layout-x-ray();
  }
}
